<template>
    <div class="container-fluid">
        <div class="row clearfix">
            <div class="col-12 ">
                <div class="row clearfix">
                    <div
                        v-for="i of agency"
                        :key="i.id"
                        :class="
                            editing
                                ? editing.id == i.id
                                    ? 'col-md-6'
                                    : 'd-none'
                                : 'col-md-6 col-sm-12'
                        "
                    >
                        <div
                            :class="
                                editing
                                    ? editing.id == i.id
                                        ? 'card xl-salmon member-card doctor'
                                        : 'card xl-blue member-card doctor'
                                    : 'card xl-blue member-card doctor'
                            "
                        >
                            <div class="body">
                                <div class="member-thumb">
                                    <img
                                        :src="i.logo ? i.logo : '/img/logo.png'"
                                        class="img-fluid"
                                        alt="profile-image"
                                    />
                                </div>
                                <div class="detail">
                                    <h4
                                        class="m-b-0"
                                        :class="
                                            template == 'dark'
                                                ? 'text-dark'
                                                : ''
                                        "
                                    >
                                        {{ i.company_name }}
                                    </h4>
                                    <p class="text-muted">
                                        {{ i.commercial_name }}
                                    </p>

                                    <a
                                        href="javascript:void(0);"
                                        @click="selectAgency(i)"
                                        class="btn btn-default btn-round btn-simple"
                                        >Asignar Admin</a
                                    >
                                </div>
                            </div>
                        </div>
                    </div>

                    <div v-if="editing" class="col-md-6">
                        <div
                            class="card member-card doctor"
                            :class="
                                template == 'dark' ? 'bg-black' : 'xl-blue-ol'
                            "
                        >
                            <div class="body">
                                <h2>
                                    {{ editing.company_name }} <br />
                                    {{ editing.commercial_name }}
                                </h2>

                                <template>
                                    <div class="row" v-if="!successMsg">
                                        <div class="col-md-10 mx-auto">
                                            <input
                                                v-model="search"
                                                class="form-control"
                                                type="text"
                                                id="searchUser"
                                                :placeholder="
                                                    field.tab1
                                                        ? field.tab1.email
                                                        : 'email'
                                                "
                                            />
                                            <div
                                                class="text-danger"
                                                v-if="!$v.search.required"
                                            >
                                                {{
                                                    field.messages
                                                        ? field.messages
                                                              .required
                                                        : "Required"
                                                }}
                                            </div>
                                            <div
                                                class="text-danger"
                                                v-if="!$v.search.email"
                                            >
                                                {{
                                                    field.messages
                                                        ? field.messages.email
                                                        : "Not is Email"
                                                }}
                                            </div>

                                            <button
                                                class="btn btn-primary btn-block"
                                                v-if="!$v.search.$invalid"
                                                @click.prevent="searchUser"
                                            >
                                                {{
                                                    field.tab1
                                                        ? field.tab1.search
                                                        : "Buscar"
                                                }}
                                            </button>
                                        </div>
                                    </div>
                                    <div
                                        class="row mt-4"
                                        v-if="sinUsuario && !successMsg"
                                    >
                                        <div class="col-md-8 mx-auto">
                                            <div class="form-group">
                                                <input
                                                    v-model="user.firstname"
                                                    type="text"
                                                    class="form-control"
                                                    :placeholder="
                                                        field.tab1
                                                            ? field.tab1
                                                                  .firstname
                                                            : 'firstname'
                                                    "
                                                />
                                                <div
                                                    class="text-danger"
                                                    v-if="
                                                        !$v.user.firstname
                                                            .required
                                                    "
                                                >
                                                    {{
                                                        field.messages
                                                            ? field.messages
                                                                  .required
                                                            : "Required"
                                                    }}
                                                </div>
                                            </div>
                                            <div class="form-group">
                                                <input
                                                    v-model="user.lastname"
                                                    type="text"
                                                    class="form-control"
                                                    :placeholder="
                                                        field.tab1
                                                            ? field.tab1
                                                                  .lastname
                                                            : 'lastname'
                                                    "
                                                />
                                                <div
                                                    class="text-danger"
                                                    v-if="
                                                        !$v.user.lastname
                                                            .required
                                                    "
                                                >
                                                    {{
                                                        field.messages
                                                            ? field.messages
                                                                  .required
                                                            : "Required"
                                                    }}
                                                </div>
                                            </div>
                                            <div class="form-group">
                                                <input
                                                    v-model="user.email"
                                                    type="email"
                                                    class="form-control"
                                                    :placeholder="
                                                        field.tab1
                                                            ? field.tab1.email
                                                            : 'e-mail'
                                                    "
                                                />
                                                <div
                                                    class="text-danger"
                                                    v-if="
                                                        !$v.user.email.required
                                                    "
                                                >
                                                    {{
                                                        field.messages
                                                            ? field.messages
                                                                  .required
                                                            : "Required"
                                                    }}
                                                </div>
                                                <div
                                                    class="text-danger"
                                                    v-if="!$v.user.email.email"
                                                >
                                                    {{
                                                        field.messages
                                                            ? field.messages
                                                                  .email
                                                            : "Not is Email"
                                                    }}
                                                </div>

                                                <button
                                                    class="btn btn-success btn-block"
                                                    v-if="!$v.user.$invalid"
                                                    @click.prevent="postUser"
                                                >
                                                    {{
                                                        field.tab1
                                                            ? field.tab1.create
                                                            : "create"
                                                    }}
                                                </button>
                                            </div>
                                        </div>
                                    </div>
                                    <div
                                        class="row"
                                        v-if="
                                            conUsuario && user.id && !successMsg
                                        "
                                    >
                                        <div class="col-8 mx-auto mt-4">
                                            <span class="text-success">
                                                <i
                                                    style="font-size:2cm"
                                                    class="zmdi zmdi-check-circle"
                                                ></i>
                                            </span>
                                            <br />
                                            <h4 class="mt-0">
                                                {{ field.user_found }}
                                            </h4>
                                            <button
                                                @click="assignAdmin"
                                                class="btn btn-block btn-success"
                                            >
                                                {{ field.see_agency }}
                                            </button>
                                        </div>
                                    </div>
                                    <div class="row" v-if="successMsg">
                                        <div class="col-8 mx-auto mt-4">
                                            <span class="text-success">
                                                <i
                                                    style="font-size:2cm"
                                                    class="zmdi zmdi-check-circle"
                                                ></i>
                                            </span>
                                            <br />
                                            <h4 class="mt-0">
                                                {{ successMsg }}
                                            </h4>
                                            <a
                                                :href="
                                                    '/dashboard/agency/show/' +
                                                        editing.id
                                                "
                                                class="btn btn-block btn-secundary"
                                            >
                                                {{ field.see_agency }}
                                            </a>
                                        </div>
                                    </div>
                                </template>
                                <div class="alert alert-danger" v-if="errorMsg">
                                    <span class="text-center"
                                        ><strong>Oh no! </strong
                                        >{{ errorMsg }}</span
                                    >
                                </div>
                                <button
                                    @click="clear()"
                                    class="btn btn-primary btn-block"
                                >
                                    {{ successMsg ? "Salir" : "Cancelar" }}
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
import { required, minLength, between, email } from "vuelidate/lib/validators";
export default {
    props: ["a", "lang", "t"],
    mounted() {
        
        this.setFiltered();
    },
    data() {
        return {
            template: this.t,
            errorMsg: null,
            successMsg: null,
            field: this.lang,
            selecting: {
                id: null
            },
            tab1: null,
            agency: this.a,
            editing: null,
            user: {},
            search: null,
            conUsuario: null,
            sinUsuario: null
        };
    },
    validations: {
        address: {
            required
        },
        search: {
            required,
            email
        },
        user: {
            email: {
                required,
                email
            },
            firstname: {
                required
            },
            lastname: {
                required
            }
        }
    },
    methods: {
        searchUser() {
            this.conUsuario = null;
            this.sinUsuario = null;
            this.errorMsg = null;
            this.user = {};
            axios
                .get("/api/users/edit/" + this.search + "?type=email")
                .then(res => {
                    this.user = res.data;
                    this.conUsuario = true;
                })
                .catch(err => {
                    this.errorMsg = err.response.data.msg;
                    this.sinUsuario = true;
                    this.user.email = this.search;
                });
        },
        postUser() {
            this.user.agency_admin = this.editing.id;
            this.errorMsg = null;
            axios
                .post("/api/users/edit", this.user)
                .then(res => {
                    console.log(this.field);
                    this.successMsg = this.field.user_created;
                })
                .catch(err => {});
        },
        assignAdmin() {
            this.errorMsg = null;
            this.user.agency_admin = this.editing.id;
            axios
                .put("/api/users/edit/" + this.user.id, this.user)
                .then(res => {
                    this.successMsg = this.field.user_assigned;
                })
                .catch(err => {
                    this.errorMsg = err.response.data.msg;
                });
        },
        setFiltered() {
            let a = JSON.parse(localStorage.getItem("agency_selected")) ?? null;
            if (a) {
                this.selecting.id = a.id;
                this.editing = a;
            }
        },
        selectAgency(ag) {
            this.editing = ag;
            localStorage.setItem("agency_selected", JSON.stringify(ag));
            this.$emit("select-agency", ag);
        },
        clear() {
            this.selecting.id = null;
            this.sinUsuario = null;
            this.editing = null;
            this.successMsg = null;
            this.user = {};
            this.errorMsg = null;
            localStorage.removeItem("agency_selected");
            this.$emit("select-agency", null);
        }
    }
};
</script>
